
        INCLUDE \masm32\include\masm32rt.inc
        .586
        INCLUDE \masm32\macros\timers.asm

; #######################################################################

;prototypes

EnumerateCpus   PROTO
smdtoa          PROTO :DWORD, :DWORD
smqtoa          PROTO :DWORD, :DWORD
umdtoa          PROTO :DWORD, :DWORD
umqtoa          PROTO :DWORD, :DWORD

; #######################################################################

        .data

        align   4

QVal1   dq      9223372036854775807
QVal2   dq      -9223372036854775808
QVal3   dq      18446744073709551615

        .data?

        align   4

AscBuf  dd      6 dup(?)

; #######################################################################

        .code

_main   PROC
; #################################

;enumerate CPUs

        INVOKE  EnumerateCpus
        print   chr$(13,10)

; #################################

;simple display tests

        invoke  smdtoa,2147483647,offset AscBuf
        print eax
        print chr$(13,10)
        invoke  smdtoa,-2147483648,offset AscBuf
        print eax
        print chr$(13,10)
        invoke  umdtoa,4294967295,offset AscBuf
        print eax
        print chr$(13,10)
        invoke  smqtoa,offset QVal1,offset AscBuf
        print eax
        print chr$(13,10)
        invoke  smqtoa,offset QVal2,offset AscBuf
        print eax
        print chr$(13,10)
        invoke  umqtoa,offset QVal3,offset AscBuf
        print eax
        print chr$(13,10,13,10)

; #################################

;select core 0

        INVOKE  GetCurrentProcess
        INVOKE  SetProcessAffinityMask,
                eax,
                1
        INVOKE  Sleep,
                500

; #################################

; smdtoa timing (positive)

LOOP_COUNT = 10000000

        print   chr$("smdtoa (2147483647)            ")

        mov     ecx,3

test00: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  smdtoa,2147483647,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test00

        print   chr$("clock cycles"),13,10

; #################################

; smdtoa timing (negative)

LOOP_COUNT = 10000000

        print   chr$("smdtoa (-2147483648)           ")

        mov     ecx,3

test01: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  smdtoa,-2147483648,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test01

        print   chr$("clock cycles"),13,10

; #################################

; umdtoa timing

LOOP_COUNT = 11450000

        print   chr$("umdtoa (4294967295)            ")

        mov     ecx,3

test02: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  umdtoa,4294967295,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test02

        print   chr$("clock cycles"),13,10

; #################################

; smqtoa timing (positive)

LOOP_COUNT = 2240000

        print   chr$("smqtoa (9223372036854775807)   ")

        mov     ecx,3

test03: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  smqtoa,offset QVal1,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test03

        print   chr$("clock cycles"),13,10

; #################################

; smqtoa timing (negative)

LOOP_COUNT = 2240000

        print   chr$("smqtoa (-9223372036854775808)  ")

        mov     ecx,3

test04: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  smqtoa,offset QVal2,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test04

        print   chr$("clock cycles"),13,10

; #################################

; umqtoa timing

LOOP_COUNT = 2450000

        print   chr$("umqtoa (18446744073709551615)  ")

        mov     ecx,3

test05: push    ecx

;----------------------------
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
;----------------------------

        invoke  umqtoa,offset QVal3,offset AscBuf

;----------------------------
        counter_end
;----------------------------

        print   str$(eax),9
        pop     ecx
        dec     ecx
        jnz     test05

        print   chr$("clock cycles"),13,10,13,10

; #################################

;terminate

        inkey
        exit

_main   ENDP

; #######################################################################
;
;                               smdtoa
;
; Procedure for converting a 32-bit signed integer to ASCII without
; any leading "0"
;
; Return:   Null-terminated ASCII string in memory
;           EAX = address of first byte of the string
;
; Usage:    invoke smdtoa,src,lpBuf
;
;   where:  
;   src   = dword to be converted
;   lpBuf = pointer to a memory buffer for the null-terminated ASCII
;           string (an 12-byte buffer is sufficient for the largest of
;           numbers, i.e. 10 digits maximum, sign, and the terminating 0)
;
; EAX, ECX and EDX are trashed. EBX, ESI and EDI are preserved.
;
; NOTE: This procedure cannot determine if the source dword is a valid
;       signed DWORD INTEGER. It is the responsibility of the
;       programmer to insure that. No error code can be returned.
;
;                       by Raymond Filiatreault
;                            Otober 2009
;                            MASM  syntax
;
; The "m" in the procedure name is to indicate that this procedure is
; based on the principal of multiplying by the reciprocal of 10 instead
; of dividing by 10, i.e. the use of "magic numbers".
;
; #######################################################################

;     .686                   ; minimum processor needed for 32 bit
;     .model flat, stdcall   ; FLAT memory model & STDCALL calling
;     option casemap :none   ; set code to case sensitive

; #######################################################################

;smdtoa PROTO :DWORD, :DWORD

.code

smdtoa proc uses ebx edi src:DWORD, lpdest:DWORD

      mov   edi,lpdest
      mov   eax,src
      add   edi,11
      mov   ecx,0CCCCCCCDh
      mov   ebx,10
      mov   byte ptr[edi],0

;      test  eax,eax
;      pushfd
;      .if   SIGN?
;            neg   eax
;      .endif

        cdq
        push    edx
        xor     eax,edx
        sub     eax,edx

   @@:
      mul   ecx
      shrd  eax,edx,3
      shr   edx,3
      inc   eax
      push  edx
      mul   ebx
      dec   edi
      add   dl,30h
      mov   [edi],dl
      pop   eax
      test  eax,eax
      jnz   @B

;      popfd
;      .if   SIGN?
;            dec   edi
;            mov   byte ptr[edi],"-"
;      .endif

        pop     edx
        mov     al,2Dh
        and     eax,edx
        jz      @F

        dec     edi
        mov     [edi],al

@@:
      mov   eax,edi
      ret

smdtoa endp

; #######################################################################
;
;                               umdtoa
;
; Procedure for converting a 32-bit unsigned integer to ASCII without
; any leading "0"
;
; Return:   Null-terminated ASCII string in memory
;           EAX = address of first byte of the string
;
; Usage:    invoke umdtoa,src,lpBuf
;
;   where:  
;   src   = dword to be converted
;   lpBuf = pointer to a memory buffer for the null-terminated ASCII
;           string (an 11-byte buffer is sufficient for the largest of
;           numbers, i.e. 10 digits maximum, and the terminating 0)
;
; EAX, ECX and EDX are trashed. EBX, ESI and EDI are preserved.
;
; NOTE: This procedure cannot determine if the source dword
;       is a valid unsigned DWORD INTEGER. It is the responsibility
;       of the programmer to insure that. No error code can be returned.
;
;                       by Raymond Filiatreault
;                            Otober 2009
;                            MASM  syntax
;
; The "m" in the procedure name is to indicate that this procedure is
; based on the principal of multiplying by the reciprocal of 10 instead
; of dividing by 10, i.e. the use of "magic numbers".
;
; #######################################################################

;     .686                   ; minimum processor needed for 32 bit
;     .model flat, stdcall   ; FLAT memory model & STDCALL calling
;     option casemap :none   ; set code to case sensitive

; #######################################################################

;umdtoa PROTO :DWORD, :DWORD

.code

umdtoa proc uses ebx edi src:DWORD, lpdest:DWORD

      mov   edi,lpdest
      mov   eax,src
      add   edi,11
      mov   ecx,0CCCCCCCDh
      mov   ebx,10
      mov   byte ptr[edi],0
   @@:
      mul   ecx
      shrd  eax,edx,3
      shr   edx,3
      inc   eax
      push  edx
      mul   ebx
      dec   edi
      add   dl,30h
      mov   [edi],dl
      pop   eax
      test  eax,eax
      jnz   @B
      mov   eax,edi
      ret

umdtoa endp

; #######################################################################
;
;                               smqtoa
;
; Procedure for converting a 64-bit signed integer from memory to ASCII
; without any leading "0"
;
; Return:   Null-terminated ASCII string in memory
;           EAX = address of first byte of the string
;
; Usage:    invoke smqtoa,lpQW,lpBuf
;
;   where:  
;   lpQW  = pointer to the location of the qword in memory
;   lpBuf = pointer to a memory buffer for the null-terminated ASCII
;           string (a 22-byte buffer is sufficient for the largest of
;           numbers, i.e. 20 digits maximum, sign and the terminating 0)
;
; EAX, ECX and EDX are trashed. EBX, ESI and EDI are preserved.
;
; NOTE: This procedure cannot determine if the data pointed to by
;       lpQW is a valid signed QWORD INTEGER. It is the responsibility
;       of the programmer to insure that. No error code can be returned.
;
;                       by Raymond Filiatreault
;                            Otober 2009
;                            MASM  syntax
;
; The "m" in the procedure name is to indicate that this procedure is
; based on the principal of multiplying by the reciprocal of 10 instead
; of dividing by 10, i.e. the use of "magic numbers".
;
; #######################################################################

;     .686                   ; minimum processor needed for 32 bit
;     .model flat, stdcall   ; FLAT memory model & STDCALL calling
;     option casemap :none   ; set code to case sensitive

; #######################################################################

;smqtoa PROTO :DWORD, :DWORD

.code

smqtoa proc uses ebx esi edi lpsrc:DWORD, lpdest:DWORD

LOCAL x10 :DWORD
LOCAL r10L :DWORD
LOCAL r10H :DWORD
LOCAL t1 :DWORD
LOCAL t2 :DWORD

      mov   esi,lpsrc
      mov   edi,lpdest
      mov   ebx,[esi]
      mov   esi,[esi+4]
      add   edi,21

;      test  esi,esi
;      pushfd
;      .if   SIGN?
;            not   esi
;            neg   ebx
;      .endif

        mov     eax,esi
        cdq
        push    edx
        xor     ebx,edx
        xor     esi,edx
        sub     ebx,edx
        sbb     esi,edx

      mov   byte ptr[edi],0
      mov   r10L,0CCCCCCCDh
      mov   r10H,0CCCCCCCCh
      mov   x10,10
   @@:
      .if   esi != 0
            xor   ecx,ecx
            mov   eax,r10L
            mul   ebx
            mov   t1,edx
            mov   eax,r10H
            mul   ebx
            add   t1,eax
            adc   edx,0
            mov   t2,edx
            mov   eax,r10L
            mul   esi
            add   t1,eax
            adc   t2,edx
            adc   ecx,0
            mov   eax,r10H
            mul   esi
            add   eax,t2
            adc   edx,ecx
            mov   ecx,t1
            shrd  ecx,eax,3
            shrd  eax,edx,3
            inc   ecx
            shr   edx,3
            mov   ebx,eax
            mov   esi,edx
            mov   eax,ecx
            mul   x10
            add   dl,30h
            dec   edi
            mov   [edi],dl
            jmp   @B
      .endif
   @@:
      mov   eax,ebx
      mul   r10L
      shrd  eax,edx,3
      shr   edx,3
      mov   ebx,edx
      inc   eax
      mul   x10
      dec   edi
      add   dl,30h
      mov   [edi],dl
      test  ebx,ebx
      jnz   @B

;      popfd
;      jns   @F
;      dec   edi
;      mov   byte ptr[edi],"-"

        pop     edx
        mov     al,2Dh
        and     eax,edx
        jz      @F

        dec     edi
        mov     [edi],al

   @@:
      mov   eax,edi
      ret

smqtoa endp

; #######################################################################
;
;                               umqtoa
;
; Procedure for converting a 64-bit unsigned integer from memory to ASCII
; without any leading "0"
;
; Return:   Null-terminated ASCII string in memory
;           EAX = address of first byte of the string
;
; Usage:    invoke umqtoa,lpQW,lpBuf
;
;   where:  
;   lpQW  = pointer to the location of the qword in memory
;   lpBuf = pointer to a memory buffer for the null-terminated ASCII
;           string (a 21-byte buffer is sufficient for the largest of
;           numbers, i.e. 20 digits maximum, and the terminating 0)
;
; EAX, ECX and EDX are trashed. EBX, ESI and EDI are preserved.
;
; NOTE: This procedure cannot determine if the data pointed to by
;       lpQW is a valid unsigned QWORD INTEGER. It is the responsibility
;       of the programmer to insure that. No error code can be returned.
;
;                       by Raymond Filiatreault
;                            Otober 2009
;                            MASM  syntax
;
; The "m" in the procedure name is to indicate that this procedure is
; based on the principal of multiplying by the reciprocal of 10 instead
; of dividing by 10, i.e. the use of "magic numbers".
;
; #######################################################################

;     .686                   ; minimum processor needed for 32 bit
;     .model flat, stdcall   ; FLAT memory model & STDCALL calling
;     option casemap :none   ; set code to case sensitive

; #######################################################################

;umqtoa PROTO :DWORD, :DWORD

.code

umqtoa proc uses ebx esi edi lpsrc:DWORD, lpdest:DWORD

LOCAL x10 :DWORD
LOCAL r10L :DWORD
LOCAL r10H :DWORD
LOCAL t1 :DWORD
LOCAL t2 :DWORD

      mov   esi,lpsrc
      mov   edi,lpdest
      mov   ebx,[esi]
      mov   esi,[esi+4]
      add   edi,20
      mov   byte ptr[edi],0
      mov   r10L,0CCCCCCCDh
      mov   r10H,0CCCCCCCCh
      mov   x10,10
   @@:
      .if   esi != 0
            xor   ecx,ecx
            mov   eax,r10L
            mul   ebx
            mov   t1,edx
            mov   eax,r10H
            mul   ebx
            add   t1,eax
            adc   edx,0
            mov   t2,edx
            mov   eax,r10L
            mul   esi
            add   t1,eax
            adc   t2,edx
            adc   ecx,0
            mov   eax,r10H
            mul   esi
            add   eax,t2
            adc   edx,ecx
            mov   ecx,t1
            shrd  ecx,eax,3
            shrd  eax,edx,3
            inc   ecx
            shr   edx,3
            mov   ebx,eax
            mov   esi,edx
            mov   eax,ecx
            mul   x10
            add   dl,30h
            dec   edi
            mov   [edi],dl
            jmp   @B
      .endif
   @@:
      mov   eax,ebx
      mul   r10L
      shrd  eax,edx,3
      shr   edx,3
      mov   ebx,edx
      inc   eax
      mul   x10
      dec   edi
      add   dl,30h
      mov   [edi],dl
      test  ebx,ebx
      jnz   @B

      mov   eax,edi
      ret

umqtoa endp

; #######################################################################

EnumerateCpus PROC

;Enumerate processor cores - written by DednDave
;this is a preliminary version - to be updated soon
;I was very careful to leave a lot of room for improvement - lol

;Call With: nothing (future versions will have mode controls)

;  Returns: displays a line of text describing total system cores
;           displays a line of text for each CPU package
;           eax = affinity mask for first core that supports RDTSC
;           DF = 0 (up)
;           ebx, ebp, esi, edi preserved

;preserve registers and initialize stack frame

;[ebp-4] = CPU number (init = 0)
;[ebp-8] = rotated affinity mask for testing (init = 1)
;[ebp-12] = current process handle
;[ebp-16] = system affinity mask
;[ebp-20] = process affinity mask/cpuid[1]eax
;[ebp-24] = total system cores
;[ebp-28] = cpuid[1]edx
;[ebp-32] = cpuid[1]ecx
;[ebp-36] = cpuid[1]ebx

        push    ebx
        push    esi
        push    edi
        push    ebp
        mov     ebp,esp
        xor     eax,eax
        push    eax
        inc     eax
        push    eax
        sub     esp,28

;get and store current process handle

        INVOKE  GetCurrentProcess
        mov     [ebp-12],eax

;get and store affinity masks

        lea     ecx,[ebp-20]
        lea     edx,[ebp-16]
        INVOKE  GetProcessAffinityMask,
                eax,
                ecx,
                edx

;enumerate total system cores

;        print   chr$('Total System Processor Cores: ')
        mov     eax,32
        mov     edx,[ebp-16]
        mov     ecx,eax

Ecpus0: shr     edx,1
        jc      Ecpus1

        dec     eax

Ecpus1: dec     ecx
        jnz     Ecpus0

        mov     [ebp-24],eax
;        print   str$(eax),13,10

;enumerate individual CPUs

Ecpus2: print   chr$('CPU ')
        print   str$(dword ptr [ebp-4]),58,32

;restrict execution to the selected core

        INVOKE  SetProcessAffinityMask,
                dword ptr [ebp-12],
                dword ptr [ebp-8]

;verify CPUID supported

        pushfd
        pop     eax
        mov     edx,eax                 ;edx=original
        xor     eax,200000h             ;eax=toggled
        push    eax
        popfd                           ;eflags=new
        pushfd
        pop     eax                     ;eax=new
        push    edx
        popfd                           ;eflags=original
        xor     eax,edx                 ;eax=toggle result
        test    eax,200000h
        jnz     Ecpus3

        print   chr$('Unknown Cores: 1'),13,10
        mov     ecx,1
        jmp     EcpusR

Ecpus3: mov     eax,1
        cpuid
        mov     [ebp-20],eax
        mov     [ebp-36],ebx
        mov     [ebp-28],edx
        mov     [ebp-32],ecx
        mov     eax,80000000h
        cpuid
        cmp     eax,80000004h
        jae     Ecpus5

;if no brand string, we show fam/mod/xfam/xmod/type/step

Ecpus4: print   chr$('Fam ')
        mov     eax,[ebp-20]
        push    eax
        shr     eax,8
        and     eax,0Fh
        print   str$(eax),32
        print   chr$('Mod ')
        pop     eax
        push    eax
        shr     eax,4
        and     eax,0Fh
        print   str$(eax),32
        print   chr$('xFam ')
        pop     eax
        push    eax
        shr     eax,20
        and     eax,0FFh
        print   str$(eax),32
        print   chr$('xMod ')
        pop     eax
        push    eax
        shr     eax,16
        and     eax,0Fh
        print   str$(eax),32
        print   chr$('Type ')
        pop     eax
        push    eax
        shr     eax,12
        and     eax,3
        print   str$(eax),32
        print   chr$('Step ')
        pop     eax
        and     eax,0Fh
        print   str$(eax),32
        jmp     Ecpus8

;brand string

Ecpus5: xor     eax,eax
        push    eax
        mov     eax,80000004h
        cpuid
        push    edx
        push    ecx
        push    ebx
        push    eax
        mov     eax,80000003h
        cpuid
        push    edx
        push    ecx
        push    ebx
        push    eax
        mov     eax,80000002h
        cpuid
        push    edx
        push    ecx
        push    ebx
        push    eax

;find the end

        cld
        xor     eax,eax
        mov     edi,esp
        mov     ecx,49
        repnz   scasb
        dec     edi
        dec     edi

;strip spaces off the end

        std
        mov     al,32
        lea     ecx,[edi+1]
        sub     ecx,esp
        repz    scasb
        jz      Ecpus6

        inc     edi

;terminate it with a space and a null

Ecpus6: mov     [edi+1],ax
        lea     esi,[edi+2]
        cld
        mov     edi,esp
        mov     ecx,48
        repz    scasb
        dec     edi

;strip out (r)'s, (tm)'s, and extra spaces
;(code to be added later)



;if less than 2 characters, give them the family/model string instead
;edi = offset of string
;esi = offset of terminator

        sub     esi,edi
        cmp     esi,2
        jbe     Ecpus4

Ecpus7: print   edi
        add     esp,52

;mmx, sse extensions
;(ia32/ia64/EM64T/AMD64 to be added later)
;(possibly HTT and SAHF if line length permits)

Ecpus8: xor     eax,eax
        cpuid
        mov     edx,16800010h
        and     edx,[ebp-28]
        mov     eax,80201h
        cmp     ecx,6C65746Eh   ;is it Intel ?
        jnz     Ecpus9

        or      eax,100000h

Ecpus9: and     eax,[ebp-32]
        or      edx,eax
        cmp     ecx,444D4163h   ;is it AMD ?
        jnz     EcpusA

        push    edx
        mov     eax,80000001h
        cpuid
        pop     eax
        and     ecx,840h
        and     edx,0C0400000h
        or      edx,eax
        or      edx,ecx

EcpusA: mov     ebx,edx
        shr     ebx,18
        mov     ax,dx
        and     ax,0A41h
        and     dl,10h
        or      ebx,eax
        shr     edx,1
        or      bl,dl

;at this point, 14 meaningful bits in BX:

;  Bit Source      Meaning
;   0  0_1[ecx:00] SSE3
;   1  0_1[ecx:19] SSE4.1
;   2  0_1[ecx:20] SSE4.2  (Intel only)
;   3  0_1[edx:04] RDTSC
;   4  8_1[edx:22] MMX+    (AMD only)
;   5  0_1[edx:23] MMX
;   6  8_1[ecx:06] SSE4a   (AMD only)
;   7  0_1[edx:25] SSE
;   8  0_1[edx:26] SSE2
;   9  0_1[ecx:09] SSSE3
;  10  0_1[edx:10] HTT
;  11  8_1[ecx:11] SSE5    (AMD only)
;  12  8_1[edx:30] 3DNow!+ (AMD only)
;  13  8_1[edx:31] 3DNow!  (AMD only)
;  14  0
;  15  0

;mmx extensions

        test    bl,10h
        jz      EcpusB

        print   chr$('MMX+ ')
        jmp short EcpusC

EcpusB: test    bl,20h
        jz      EcpusP          ;if no mmx, no sse or 3dnow either

        print   chr$('MMX ')

;sse extensions

EcpusC: test    bh,8
        jz      EcpusD

        print   chr$('SSE5 ')
        jmp short EcpusK

EcpusD: test    bl,40h
        jz      EcpusE

        print   chr$('SSE4a ')
        jmp short EcpusK

EcpusE: test    bl,4
        jz      EcpusF

        print   chr$('SSE4.2 ')
        jmp short EcpusP        ;if sse4.2 it's Intel, so no 3dnow

EcpusF: test    bl,2
        jz      EcpusG

        print   chr$('SSE4.1 ')
        jmp short EcpusK

EcpusG: test    bh,2
        jz      EcpusH

        print   chr$('SSSE3 ')
        jmp short EcpusK

EcpusH: test    bl,1
        jz      EcpusI

        print   chr$('SSE3 ')
        jmp short EcpusK

EcpusI: test    bh,1
        jz      EcpusJ

        print   chr$('SSE2 ')
        jmp short EcpusK

EcpusJ: test    bl,80h
        jz      EcpusK

        print   chr$('SSE ')

;3dnow extensions

EcpusK: test    bh,10h
        jz      EcpusL

        print   chr$('3DNow!+ ')
        jmp short EcpusP

EcpusL: test    bh,20h
        jz      EcpusP

        print   chr$('3DNow! ')

;count cores in package

EcpusP: mov     ecx,1
        test    bh,4
        jz      EcpusQ

        mov     ecx,[ebp-36]
        shr     ecx,16
        mov     ch,0

EcpusQ: push    ecx
        print   chr$('Cores: ')
        mov     eax,[esp]
        print   str$(eax),13,10
        pop     ecx

;next core

EcpusR: mov     eax,[ebp-8]

EcpusS: shl     eax,1
        jc      EcpusT

        mov     edx,[ebp-16]
        cmp     eax,edx
        ja      EcpusT

        test    eax,edx
        jz      EcpusS

        dec     ecx
        jnz     EcpusS

        mov     [ebp-8],eax
        inc dword ptr [ebp-4]
        jmp     Ecpus2

;exit the routine

EcpusT: INVOKE  SetProcessAffinityMask,
                dword ptr [ebp-12],
                dword ptr [ebp-16]
        leave
        pop     edi
        pop     esi
        pop     ebx
        ret

EnumerateCpus ENDP

; #######################################################################

        END     _main
